diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
index b5566f80a..553869805 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
@@ -20,36 +20,36 @@ public class ChunkGeneratorSkyblock
         // Starting island
         for (int x = -1; x <= 1; x++) {
             for (int z = -1; z <= 1; z++) {
-                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id);
-                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id);
-                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id);
+                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id());
+                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id());
+                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id());
             }
         }
         for (int x = -1; x <= 1; x++) {
             for (int z = -4; z <= -2; z++) {
-                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id);
-                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id);
-                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id);
+                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id());
+                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id());
+                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id());
             }
         }
         for (int x = 2; x <= 4; x++) {
             for (int z = -4; z <= -2; z++) {
-                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id);
-                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id);
-                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id);
+                tryPlace(chunk, result, x, 64, z, Blocks.DIRT.id());
+                tryPlace(chunk, result, x, 65, z, Blocks.DIRT.id());
+                tryPlace(chunk, result, x, 66, z, Blocks.GRASS.id());
             }
         }
-        tryPlace(chunk, result, 0, 64, -3, Blocks.BEDROCK.id);
+        tryPlace(chunk, result, 0, 64, -3, Blocks.BEDROCK.id());
 
         // Desert island
         for (int x = -68; x <= -66; x++) {
             for (int z = -1; z <= 1; z++) {
-                tryPlace(chunk, result, x, 64, z, Blocks.SAND.id);
-                tryPlace(chunk, result, x, 65, z, Blocks.SAND.id);
-                tryPlace(chunk, result, x, 66, z, Blocks.SAND.id);
+                tryPlace(chunk, result, x, 64, z, Blocks.SAND.id());
+                tryPlace(chunk, result, x, 65, z, Blocks.SAND.id());
+                tryPlace(chunk, result, x, 66, z, Blocks.SAND.id());
             }
         }
-        tryPlace(chunk, result, -68, 67, 1, Blocks.CACTUS.id);
+        tryPlace(chunk, result, -68, 67, 1, Blocks.CACTUS.id());
 
         return result;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
index 348b4ef84..3fe19c1dd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
@@ -20,25 +20,25 @@ public class ChunkGeneratorSkyblockNether
         // Main island
         for (int x = -1; x <= 1; x++) {
             for (int z = -1; z <= 1; z++) {
-                tryPlace(chunk, result, x, 63, z, Blocks.GLOWSTONE.id);
-                tryPlace(chunk, result, x, 64, z, Blocks.GLOWSTONE.id);
-                tryPlace(chunk, result, x, 65, z, Blocks.GLOWSTONE.id);
+                tryPlace(chunk, result, x, 63, z, Blocks.GLOWSTONE.id());
+                tryPlace(chunk, result, x, 64, z, Blocks.GLOWSTONE.id());
+                tryPlace(chunk, result, x, 65, z, Blocks.GLOWSTONE.id());
             }
         }
         // Portal
         for (int z = -1; z <= 2; z++) {
             if (z == -1 || z == 2) {
-                tryPlace(chunk, result, 2, 65, z, Blocks.OBSIDIAN.id);
-                tryPlace(chunk, result, 2, 66, z, Blocks.OBSIDIAN.id);
-                tryPlace(chunk, result, 2, 67, z, Blocks.OBSIDIAN.id);
-                tryPlace(chunk, result, 2, 68, z, Blocks.OBSIDIAN.id);
-                tryPlace(chunk, result, 2, 69, z, Blocks.OBSIDIAN.id);
+                tryPlace(chunk, result, 2, 65, z, Blocks.OBSIDIAN.id());
+                tryPlace(chunk, result, 2, 66, z, Blocks.OBSIDIAN.id());
+                tryPlace(chunk, result, 2, 67, z, Blocks.OBSIDIAN.id());
+                tryPlace(chunk, result, 2, 68, z, Blocks.OBSIDIAN.id());
+                tryPlace(chunk, result, 2, 69, z, Blocks.OBSIDIAN.id());
             } else {
-                tryPlace(chunk, result, 2, 65, z, Blocks.OBSIDIAN.id);
-                tryPlace(chunk, result, 2, 66, z, Blocks.PORTAL_NETHER.id);
-                tryPlace(chunk, result, 2, 67, z, Blocks.PORTAL_NETHER.id);
-                tryPlace(chunk, result, 2, 68, z, Blocks.PORTAL_NETHER.id);
-                tryPlace(chunk, result, 2, 69, z, Blocks.OBSIDIAN.id);
+                tryPlace(chunk, result, 2, 65, z, Blocks.OBSIDIAN.id());
+                tryPlace(chunk, result, 2, 66, z, Blocks.PORTAL_NETHER.id());
+                tryPlace(chunk, result, 2, 67, z, Blocks.PORTAL_NETHER.id());
+                tryPlace(chunk, result, 2, 68, z, Blocks.PORTAL_NETHER.id());
+                tryPlace(chunk, result, 2, 69, z, Blocks.OBSIDIAN.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
index 5f9af8da6..678b53444 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureAlgae.java
@@ -17,10 +17,10 @@ public class WorldFeatureAlgae extends WorldFeature
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if((world.getBlockId(i1, j1, k1) == Blocks.FLUID_WATER_STILL.id) &&
+            if((world.getBlockId(i1, j1, k1) == Blocks.FLUID_WATER_STILL.id()) &&
                     world.getBlockMaterial(i1, j1+1, k1) == Material.air)
             {
-                world.setBlock(i1, j1+1, k1, Blocks.ALGAE.id);
+                world.setBlock(i1, j1+1, k1, Blocks.ALGAE.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java
index 12d59dc55..bf456c757 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCactus.java
@@ -29,7 +29,7 @@ public class WorldFeatureCactus extends WorldFeature
             {
                 if(Blocks.CACTUS.canBlockStay(world, i1, j1 + i2, k1))
                 {
-                    world.setBlock(i1, j1 + i2, k1, Blocks.CACTUS.id);
+                    world.setBlock(i1, j1 + i2, k1, Blocks.CACTUS.id());
                 }
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
index 69fdb2ff3..16486fda5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
@@ -18,11 +18,11 @@ public class WorldFeatureClay extends WorldFeature
 	}
 
     @MethodParametersAnnotation(names = {"numberOfBlocks", "block"})
-    public WorldFeatureClay(int numberOfBlocks, Block block)
+    public WorldFeatureClay(int numberOfBlocks, Block<?> block)
     {
-        clayBlockId = Blocks.BLOCK_CLAY.id;
+        clayBlockId = Blocks.BLOCK_CLAY.id();
         this.numberOfBlocks = numberOfBlocks;
-        this.generateInId = block.id;
+        this.generateInId = block.id();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
index 06485a40d..dde55c3c2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -19,7 +19,7 @@ public class WorldFeatureDeadBush extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.hasLogicClass(Blocks.blocksList[l], BlockLogicLeavesBase.class)) && y > 0; y--) { }
         for(int i1 = 0; i1 < 4; i1++)
         {
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
index 56f6880bd..9f665a455 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
@@ -2,7 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.block.BlockChest;
+import net.minecraft.core.block.BlockLogicChest;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.item.Item;
@@ -11,6 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -18,12 +19,12 @@ public class WorldFeatureDungeon extends WorldFeature
 {
 	public int blockIdWalls;
 	public int blockIdFloor;
-	public String mobOverride;
+	public @Nullable String mobOverride;
     public WeightedRandomBag<WeightedRandomLootObject> chestLoot;
     public WeightedRandomBag<String> spawnerMonsters;
 
     @MethodParametersAnnotation(names = {"blockIdWalls", "blockIdFloor", "mobOverrideDispatcherId"})
-    public WorldFeatureDungeon(int blockIdWalls, int blockIdFloor, String mobOverride)
+    public WorldFeatureDungeon(int blockIdWalls, int blockIdFloor, @Nullable String mobOverride)
     {
     	this.blockIdWalls = blockIdWalls;
     	this.blockIdFloor = blockIdFloor;
@@ -154,8 +155,8 @@ public class WorldFeatureDungeon extends WorldFeature
                 {
                     continue;
                 }
-                world.setBlockWithNotify(k3, l3, i4, Blocks.CHEST_PLANKS_OAK.id);
-                BlockChest.setDefaultDirection(world, k3, l3, i4);
+                world.setBlockWithNotify(k3, l3, i4, Blocks.CHEST_PLANKS_OAK.id());
+                BlockLogicChest.setDefaultDirection(world, k3, l3, i4);
                 TileEntityChest tileentitychest = (TileEntityChest)world.getBlockEntity(k3, l3, i4);
                 int k4 = 0;
                 do
@@ -175,7 +176,7 @@ public class WorldFeatureDungeon extends WorldFeature
 
         }
 
-        world.setBlockWithNotify(x, y, z, Blocks.MOBSPAWNER.id);
+        world.setBlockWithNotify(x, y, z, Blocks.MOBSPAWNER.id());
         TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getBlockEntity(x, y, z);
         tileentitymobspawner.setMobId(pickMobSpawner(random));
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
index eb05c08d8..f2506450d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
@@ -20,9 +20,9 @@ public class WorldFeatureFire extends WorldFeature
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.COBBLE_NETHERRACK.id)
+            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.COBBLE_NETHERRACK.id())
             {
-                world.setBlockWithNotify(i1, j1, k1, Blocks.FIRE.id);
+                world.setBlockWithNotify(i1, j1, k1, Blocks.FIRE.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
index 438e8196f..1fec14e6e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFlowerStackable;
+import net.minecraft.core.block.BlockLogicFlowerStackable;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -32,7 +32,7 @@ public class WorldFeatureFlowers extends WorldFeature
             if(world.isAirBlock(i1, j1, k1) && Blocks.blocksList[plantBlockId].canBlockStay(world, i1, j1, k1))
             {
                 final int metadata;
-                if (Blocks.getBlock(plantBlockId) instanceof BlockFlowerStackable) {
+                if (Block.hasLogicClass(Blocks.getBlock(plantBlockId), BlockLogicFlowerStackable.class)) {
                     final int stackSize;
                     if (varyStackSize) {
                         stackSize = getStackSize(random);
@@ -40,7 +40,7 @@ public class WorldFeatureFlowers extends WorldFeature
                         stackSize = 0;
                     }
 
-                    metadata = BlockFlowerStackable.setStackCount(0, stackSize);
+                    metadata = BlockLogicFlowerStackable.setStackCount(0, stackSize);
                 } else {
                     metadata = 0;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
index 559d5976f..12160f7f5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
@@ -19,11 +19,11 @@ public class WorldFeatureGlowstoneA extends WorldFeature
         {
             return false;
         }
-        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id())
         {
             return false;
         }
-        world.setBlockWithNotify(x, y, z, Blocks.GLOWSTONE.id);
+        world.setBlockWithNotify(x, y, z, Blocks.GLOWSTONE.id());
         for(int l = 0; l < 1500; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
@@ -61,7 +61,7 @@ public class WorldFeatureGlowstoneA extends WorldFeature
                 {
                     j2 = world.getBlockId(i1, j1, k1 + 1);
                 }
-                if(j2 == Blocks.GLOWSTONE.id)
+                if(j2 == Blocks.GLOWSTONE.id())
                 {
                     l1++;
                 }
@@ -69,7 +69,7 @@ public class WorldFeatureGlowstoneA extends WorldFeature
 
             if(l1 == 1)
             {
-                world.setBlockWithNotify(i1, j1, k1, Blocks.GLOWSTONE.id);
+                world.setBlockWithNotify(i1, j1, k1, Blocks.GLOWSTONE.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
index 17420a09f..9439efc5c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
@@ -19,11 +19,11 @@ public class WorldFeatureGlowstoneB extends WorldFeature
         {
             return false;
         }
-        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id())
         {
             return false;
         }
-        world.setBlockWithNotify(x, y, z, Blocks.GLOWSTONE.id);
+        world.setBlockWithNotify(x, y, z, Blocks.GLOWSTONE.id());
         for(int l = 0; l < 1500; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
@@ -61,7 +61,7 @@ public class WorldFeatureGlowstoneB extends WorldFeature
                 {
                     j2 = world.getBlockId(i1, j1, k1 + 1);
                 }
-                if(j2 == Blocks.GLOWSTONE.id)
+                if(j2 == Blocks.GLOWSTONE.id())
                 {
                     l1++;
                 }
@@ -69,7 +69,7 @@ public class WorldFeatureGlowstoneB extends WorldFeature
 
             if(l1 == 1)
             {
-                world.setBlockWithNotify(i1, j1, k1, Blocks.GLOWSTONE.id);
+                world.setBlockWithNotify(i1, j1, k1, Blocks.GLOWSTONE.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
index 5b85c4b63..4ae08760a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
@@ -58,7 +58,7 @@ public class WorldFeatureGrassPatch extends WorldFeature
                         double d14 = (((double)i3 + 0.5D) - d8) / (d10 / 2D);
                         if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D)
                         {
-                            if(world.getBlockId(k2, l2, i3) == Blocks.DIRT.id || world.getBlockId(k2, l2, i3) == Blocks.GRASS.id)
+                            if(world.getBlockId(k2, l2, i3) == Blocks.DIRT.id() || world.getBlockId(k2, l2, i3) == Blocks.GRASS.id())
                                 world.setBlockAndMetadata(k2, l2, i3, blockToPlace, 0);
                         }
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index 7d08f4f10..7fedd3a98 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -2,8 +2,8 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.block.BlockChest;
-import net.minecraft.core.block.BlockRotatable;
+import net.minecraft.core.block.BlockLogicChest;
+import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
@@ -30,11 +30,11 @@ public class WorldFeatureLabyrinth extends WorldFeature
     boolean treasureGenerated = false;
     boolean libraryGenerated = false;
     boolean isCold = false;
-    int wallBlockA = Blocks.COBBLE_STONE.id;
-    int wallBlockB = Blocks.COBBLE_STONE_MOSSY.id;
-    int brickBlockA = Blocks.BRICK_STONE_POLISHED.id;
-    int brickBlockB = Blocks.BRICK_STONE_POLISHED_MOSSY.id;
-    int slabBlock = Blocks.SLAB_STONE_POLISHED.id;
+    int wallBlockA = Blocks.COBBLE_STONE.id();
+    int wallBlockB = Blocks.COBBLE_STONE_MOSSY.id();
+    int brickBlockA = Blocks.BRICK_STONE_POLISHED.id();
+    int brickBlockB = Blocks.BRICK_STONE_POLISHED_MOSSY.id();
+    int slabBlock = Blocks.SLAB_STONE_POLISHED.id();
     public ItemStack treasureItem;
     public WeightedRandomBag<WeightedRandomLootObject> chestLoot;
     public WeightedRandomBag<WeightedRandomLootObject> dispenserLoot;
@@ -46,18 +46,18 @@ public class WorldFeatureLabyrinth extends WorldFeature
 
         if (biome == Biomes.OVERWORLD_DESERT || biome == Biomes.OVERWORLD_OUTBACK)
         {
-            wallBlockA = Blocks.SANDSTONE.id;
-            wallBlockB = Blocks.SANDSTONE.id;
-            brickBlockA = Blocks.BRICK_SANDSTONE.id;
-            brickBlockB = Blocks.BRICK_SANDSTONE.id;
-            slabBlock = Blocks.SLAB_SANDSTONE.id;
+            wallBlockA = Blocks.SANDSTONE.id();
+            wallBlockB = Blocks.SANDSTONE.id();
+            brickBlockA = Blocks.BRICK_SANDSTONE.id();
+            brickBlockB = Blocks.BRICK_SANDSTONE.id();
+            slabBlock = Blocks.SLAB_SANDSTONE.id();
         }
         if (biome == Biomes.OVERWORLD_TAIGA || biome == Biomes.OVERWORLD_TUNDRA || biome == Biomes.OVERWORLD_GLACIER)
         {
-            wallBlockA = Blocks.PERMAFROST.id;
-            wallBlockB = Blocks.COBBLE_PERMAFROST.id;
-            brickBlockA = Blocks.BRICK_PERMAFROST.id;
-            brickBlockB = Blocks.BRICK_PERMAFROST.id;
+            wallBlockA = Blocks.PERMAFROST.id();
+            wallBlockB = Blocks.COBBLE_PERMAFROST.id();
+            brickBlockA = Blocks.BRICK_PERMAFROST.id();
+            brickBlockB = Blocks.BRICK_PERMAFROST.id();
             isCold = true;
         }
 
@@ -142,10 +142,10 @@ public class WorldFeatureLabyrinth extends WorldFeature
                         //generate traps
                         if (!generateTrapOnWall && (xWallCheck || zWallCheck)) {
                             if ((x == blockZ || z == blockZ) && y == blockY) {
-                                world.setBlockWithNotify(x, y, z, Blocks.MOTION_SENSOR_IDLE.id);
-                                BlockRotatable.setDefaultDirection(world, x, y, z);
-                                world.setBlockWithNotify(x, y - 1, z, Blocks.DISPENSER_COBBLE_STONE.id);
-                                BlockRotatable.setDefaultDirection(world, x, y - 1, z);
+                                world.setBlockWithNotify(x, y, z, Blocks.MOTION_SENSOR_IDLE.id());
+                                BlockLogicRotatable.setDefaultDirection(world, x, y, z);
+                                world.setBlockWithNotify(x, y - 1, z, Blocks.DISPENSER_COBBLE_STONE.id());
+                                BlockLogicRotatable.setDefaultDirection(world, x, y - 1, z);
                                 TileEntityDispenser tileEntityDispenser = (TileEntityDispenser) world.getBlockEntity(x, blockY - 1, z);
                                 int k4 = 0;
                                 while (k4 < 3) {
@@ -189,7 +189,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                         if (yWallCheck) {
                             world.setBlockWithNotify(x, y, z, wallBlockB);
                             if(dungeonSize >= 10)
-                                world.setBlockWithNotify(x, y+1, z, Blocks.SPIKES.id);
+                                world.setBlockWithNotify(x, y+1, z, Blocks.SPIKES.id());
                         }
                         else if (x != blockX && z != blockZ && random.nextInt(20) == 0 && world.getBlockId(x, y + 1, z) != slabBlock)
                         {
@@ -215,9 +215,9 @@ public class WorldFeatureLabyrinth extends WorldFeature
     private boolean canReplace(World world, int x, int y, int z){
         if(y <= 11)
             return false;
-        if(world.getBlockId(x, y, z) == (brickBlockA) || world.getBlockId(x, y, z) == Blocks.PLANKS_OAK.id || world.getBlockId(x, y, z) == Blocks.COBWEB.id || world.getBlockId(x, y, z) == Blocks.BOOKSHELF_PLANKS_OAK.id || world.getBlockId(x, y, z) == Blocks.MOBSPAWNER.id || world.getBlockId(x, y, z) == brickBlockB )
+        if(world.getBlockId(x, y, z) == (brickBlockA) || world.getBlockId(x, y, z) == Blocks.PLANKS_OAK.id() || world.getBlockId(x, y, z) == Blocks.COBWEB.id() || world.getBlockId(x, y, z) == Blocks.BOOKSHELF_PLANKS_OAK.id() || world.getBlockId(x, y, z) == Blocks.MOBSPAWNER.id() || world.getBlockId(x, y, z) == brickBlockB )
             return false;
-        if(world.getBlockId(x, y, z) == Blocks.MOTION_SENSOR_IDLE.id || world.getBlockId(x, y, z) == Blocks.DISPENSER_COBBLE_STONE.id || world.getBlockId(x, y, z) == Blocks.MOTION_SENSOR_ACTIVE.id) {
+        if(world.getBlockId(x, y, z) == Blocks.MOTION_SENSOR_IDLE.id() || world.getBlockId(x, y, z) == Blocks.DISPENSER_COBBLE_STONE.id() || world.getBlockId(x, y, z) == Blocks.MOTION_SENSOR_ACTIVE.id()) {
             world.removeBlockTileEntity(x, y, z);
             world.setBlockWithNotify(x, y, z, 0);
             return true;
@@ -303,7 +303,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                             else world.setBlockWithNotify(x, y, z, 0);
                         }
                         if(y == blockY + (height - 1) && !zWallCheck && !xWallCheck && random.nextInt(20)==0)
-                            world.setBlockWithNotify(x, y, z, Blocks.COBWEB.id);
+                            world.setBlockWithNotify(x, y, z, Blocks.COBWEB.id());
                     }
                 }
             }
@@ -373,8 +373,8 @@ public class WorldFeatureLabyrinth extends WorldFeature
         int chestX = blockX + random.nextInt(size-1) - (size-1);
         int chestZ = blockZ + random.nextInt(size-1) - (size-1);
         if(canReplace(world, chestX, blockY-2, chestZ)) {
-            world.setBlockWithNotify(chestX, blockY - 1, chestZ, Blocks.CHEST_PLANKS_OAK.id);
-            BlockChest.setDefaultDirection(world, chestX, blockY - 1, chestZ);
+            world.setBlockWithNotify(chestX, blockY - 1, chestZ, Blocks.CHEST_PLANKS_OAK.id());
+            BlockLogicChest.setDefaultDirection(world, chestX, blockY - 1, chestZ);
             TileEntityChest tileentitychest = (TileEntityChest) world.getBlockEntity(chestX, blockY - 1, chestZ);
             int k4 = 0;
             while (k4 < 10) {
@@ -387,7 +387,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
         }
         if (doSpawner)
         {
-            world.setBlockWithNotify(blockX, blockY-1, blockZ, Blocks.MOBSPAWNER.id);
+            world.setBlockWithNotify(blockX, blockY-1, blockZ, Blocks.MOBSPAWNER.id());
             TileEntityMobSpawner tileentitymobspawner = (TileEntityMobSpawner)world.getBlockEntity(blockX, blockY-1, blockZ);
             if(tileentitymobspawner != null)
                 tileentitymobspawner.setMobId(pickMobSpawner(random));
@@ -420,7 +420,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
                         }
                         else if (yWallCheck) {
                             if((x > blockX-2 && x < blockX+2) || (z > blockZ-2 && z < blockZ+2))
-                                world.setBlockWithNotify(x, y, z, Blocks.PLANKS_OAK.id);
+                                world.setBlockWithNotify(x, y, z, Blocks.PLANKS_OAK.id());
                             else if (random.nextInt(5) == 0)
                                 world.setBlockWithNotify(x, y, z, wallBlockB);
                             else
@@ -440,12 +440,12 @@ public class WorldFeatureLabyrinth extends WorldFeature
                                     && (z <= blockZ - 1 || z >= blockZ + 1)
                                     && y < blockY + 2) {
                                 if(xRoom % 2 == 0)
-                                    world.setBlockWithNotify(x, y, z, Blocks.BOOKSHELF_PLANKS_OAK.id);
+                                    world.setBlockWithNotify(x, y, z, Blocks.BOOKSHELF_PLANKS_OAK.id());
                                 else
                                     if (random.nextInt(5) == 0)
-                                        world.setBlockWithNotify(x, y, z, Blocks.LOG_OAK_MOSSY.id);
+                                        world.setBlockWithNotify(x, y, z, Blocks.LOG_OAK_MOSSY.id());
                                     else
-                                        world.setBlockWithNotify(x, y, z, Blocks.LOG_OAK.id);
+                                        world.setBlockWithNotify(x, y, z, Blocks.LOG_OAK.id());
                             }
                             else
                                 world.setBlockWithNotify(x, y, z, 0);
